# Compilation and Installation

1. Unix / X11
2. Windows
3. VMS
4. Other

## 1. Unix/X11 Compilation and Installation

### 1.1 Compilation

Mesa may be compiled in several different ways:

- Stand-alone/Xlib mode - Mesa is compiled as a software renderer using Xlib to do all rendering. libGL.so is a self-contained rendering library.

  To compile stand-alone Mesa type make in the top-level directory. You'll see a list of supported system configurations. Choose one from the list (such as linux-x86), and type:

          make linux-x86

  This will produce libGL.so and several other libraries

- DRI/accelerated - The DRI hardware drivers (for ATI, Intel, Matrox, etc) are built. libGL.so implements the GLX extension and dynamically loads the DRI drivers.

  To build the DRI drivers you'll first need to have the DRM (Direct Rendering Manager) kernel drivers and header files. They're available from the DRI project.

  Your distribution should already have both the kernel modules and support library already installed. If not, you can get them from CVS by doing:

      cvs -z3 -d:pserver:anonymous@anoncvs.freedesktop.org:/cvs/dri co drm

  See the DRI Building Instructions for the steps to build the DRM modules. Mesa 6.5 requires at least libdrm 2.0.1 or greater.

  Build Mesa and the DRI drivers by running

      make linux-dri

  There are also `linux-dri-x86`, `linux-dri-x86-64`, and `linux-ppc` configurations, optimized for those architectures.

  Finally, you'll need a DRI-enabled X server from X.org or XFree86. Visit those projects' home pages for more information.

Later, if you want to rebuild for a different configuration run `make realclean` before rebuilding.

### 1.2 The libraries

When compilation has finished, look in the top-level `lib/` directory. You'll see a set of library files similar to this:

    lrwxrwxrwx    1 brian    users          10 Mar 26 07:53 libGL.so -> libGL.so.1*
    lrwxrwxrwx    1 brian    users          19 Mar 26 07:53 libGL.so.1 -> libGL.so.1.5.060100*
    -rwxr-xr-x    1 brian    users     3375861 Mar 26 07:53 libGL.so.1.5.060100*
    lrwxrwxrwx    1 brian    users          11 Mar 26 07:53 libGLU.so -> libGLU.so.1*
    lrwxrwxrwx    1 brian    users          20 Mar 26 07:53 libGLU.so.1 -> libGLU.so.1.3.060100*
    -rwxr-xr-x    1 brian    users      549269 Mar 26 07:53 libGLU.so.1.3.060100*
    lrwxrwxrwx    1 brian    users          12 Mar 26 07:53 libglut.so -> libglut.so.3*
    lrwxrwxrwx    1 brian    users          16 Mar 26 07:53 libglut.so.3 -> libglut.so.3.7.1*
    -rwxr-xr-x    1 brian    users      597754 Mar 26 07:53 libglut.so.3.7.1*
    lrwxrwxrwx    1 brian    users          11 Mar 26 08:04 libGLw.so -> libGLw.so.1*
    lrwxrwxrwx    1 brian    users          15 Mar 26 08:04 libGLw.so.1 -> libGLw.so.1.0.0*
    -rwxr-xr-x    1 brian    users       20750 Mar 26 08:04 libGLw.so.1.0.0*
    lrwxrwxrwx    1 brian    users          14 Mar 26 07:53 libOSMesa.so -> libOSMesa.so.6*
    lrwxrwxrwx    1 brian    users          23 Mar 26 07:53 libOSMesa.so.6 -> libOSMesa.so.6.1.060100*
    -rwxr-xr-x    1 brian    users       23871 Mar 26 07:53 libOSMesa.so.6.1.060100*

libGL is the main OpenGL library (i.e. Mesa).
libGLU is the OpenGL Utility library.
libglut is the GLUT library.
libGLw is the Xt/Motif OpenGL drawing area widget library.
libOSMesa is the OSMesa (Off-Screen) interface library.

If you built the DRI hardware drivers, you'll also see the DRI drivers:

    -rwxr-xr-x   1 brian users 11320803 Jul 21 12:11 mach64_dri.so
    -rwxr-xr-x   1 brian users 11418014 Jul 21 12:12 mga_dri.so
    -rwxr-xr-x   1 brian users 11064426 Jul 21 12:12 r128_dri.so
    -rwxr-xr-x   1 brian users 11849858 Jul 21 12:12 r200_dri.so
    -rwxr-xr-x   1 brian users 11757388 Jul 21 12:12 radeon_dri.so
    -rwxr-xr-x   1 brian users 11232304 Jul 21 12:13 s3v_dri.so
    -rwxr-xr-x   1 brian users 11062970 Jul 21 12:13 savage_dri.so
    -rwxr-xr-x   1 brian users 11214212 Jul 21 12:13 sis_dri.so
    -rwxr-xr-x   1 brian users 11368736 Jul 21 12:13 tdfx_dri.so
    -rwxr-xr-x   1 brian users 10598868 Jul 21 12:13 trident_dri.so
    -rwxr-xr-x   1 brian users 10997120 Jul 21 12:13 unichrome_dri.so

### 1.3 Running the demos

If you downloaded/unpacked the MesaDemos-x.y.z.tar.gz archive or obtained Mesa from CVS, the progs/ directory will contain a bunch of demonstration programs.

Before running a demo, you may have to set an environment variable (such as LD_LIBRARY_PATH on Linux) to indicate where the libraries are located. For example:

> cd into the Mesa lib/ directory.
> setenv LD_LIBRARY_PATH ${cwd} (if using csh or tcsh shell)
> or,
> export LD_LIBRARY_PATH=${PWD} (if using bash or sh shell)

Next, change to the Mesa/demos/ directory:

> cd ../progs/demos

Run a demo such as gears:

> ./gears

If this doesn't work, try the Mesa/progs/xdemos/glxinfo program and see that it prints the expected Mesa version number.

If you're using Linux or a similar OS, verify that the demo program is being linked with the proper library files:

> ldd gears

You should see something like this:

            libglut.so.3 => /home/brian/Mesa/lib/libglut.so.3 (0x40013000)
            libGLU.so.1 => /home/brian/Mesa/lib/libGLU.so.1 (0x40051000)
            libGL.so.1 => /home/brian/Mesa/lib/libGL.so.1 (0x400e0000)
            libc.so.6 => /lib/i686/libc.so.6 (0x42000000)
            libm.so.6 => /lib/i686/libm.so.6 (0x403da000)
            libX11.so.6 => /usr/X11R6/lib/libX11.so.6 (0x403fc000)
            libXmu.so.6 => /usr/X11R6/lib/libXmu.so.6 (0x404da000)
            libXt.so.6 => /usr/X11R6/lib/libXt.so.6 (0x404f1000)
            libXi.so.6 => /usr/X11R6/lib/libXi.so.6 (0x40543000)
            libstdc++.so.5 => /usr/lib/libstdc++.so.5 (0x4054b000)
            libgcc_s.so.1 => /lib/libgcc_s.so.1 (0x405fd000)
            libXext.so.6 => /usr/X11R6/lib/libXext.so.6 (0x40605000)
            libpthread.so.0 => /lib/i686/libpthread.so.0 (0x40613000)
            /lib/ld-linux.so.2 => /lib/ld-linux.so.2 (0x40000000)
            libdl.so.2 => /lib/libdl.so.2 (0x40644000)
            libSM.so.6 => /usr/X11R6/lib/libSM.so.6 (0x40647000)
            libICE.so.6 => /usr/X11R6/lib/libICE.so.6 (0x40650000)

Retrace your steps if this doesn't look right.

### 1.4 Installing the header and library files

The standard location for the OpenGL header files on Unix-type systems is in `/usr/include/GL/`. The standard location for the libraries is `/usr/lib/`. For more information see, the Linux/OpenGL ABI specification.

If you'd like Mesa to co-exist with another implementation of OpenGL that's already installed, you'll have to choose different directories, like `/usr/local/include/GL/` and `/usr/local/lib/`.

To install Mesa's headers and libraries, run `make install` You'll be prompted to enter alternative directories for the headers and libraries.

Note: at runtime, you can set the LD_LIBRARY_PATH (on Linux) to switch between the Mesa libs and another vendor libs whenever you want. This is a handy way to compare multiple OpenGL implementations.

## 2. Windows Compilation and Installation

Please see the README.WIN32 file.

## 3. VMS Compilation and Installation

Please see the README.VMS file.

## 4. Other systems

Documentation for other environments (some may be very out of date):

- README.GGI - GGI
- README.3DFX - 3Dfx/Glide driver
- README.AMIWIN - Amiga Amiwin
- README.BEOS - BeOS
- README.D3D - Direct3D driver
- README.DJ - DJGPP
- README.LYNXOS - LynxOS
- README.MINGW32 - Mingw32
- README.NeXT - NeXT
- README.OpenStep - OpenStep
- README.OS2 - OS/2
- README.WINDML - WindML